-- #hide
-----------------------------------------------------------------------------
-- |
-- Module      :  OS.Clipboard
-- Copyright   :  (c) Krasimir Andreev 2002
-- License     :  BSD-style
-- 
-- Maintainer  :  ka2_mail@yahoo.com
-- Stability   :  provisional
-- Portability :  portable
--
-- ClCrossCall_12 contains the operations to communicate between
-- Clipboard operations.
--
-----------------------------------------------------------------------------

module Graphics.UI.ObjectIO.OS.Clipboard where


import Graphics.UI.ObjectIO.OS.ClipboardCrossCall_12

type OSClipboardItemType = Int

osClipboardText = 1	-- CF_TEXT

osHasClipboardText :: IO Bool
osHasClipboardText = winHasClipboardText

osSetClipboardText :: String -> IO ()
osSetClipboardText text = winSetClipboardText text

osGetClipboardText :: IO String
osGetClipboardText = winGetClipboardText

osGetClipboardContent :: IO [OSClipboardItemType]
osGetClipboardContent = do
	hasText <- winHasClipboardText
	return (if hasText then [osClipboardText] else [])

osGetClipboardVersion :: IO Int
osGetClipboardVersion = winGetClipboardCount
