-- #hide
-----------------------------------------------------------------------------
-- |
-- Module      :  OS.RgnCCall_12
-- Copyright   :  (c) Krasimir Andreev 2002
-- License     :  BSD-style
-- 
-- Maintainer  :  ka2_mail@yahoo.com
-- Stability   :  provisional
-- Portability :  portable
--
-- OS.RgnCCall_12 contains OS operations to manage regions.
--
-----------------------------------------------------------------------------

module Graphics.UI.ObjectIO.OS.RgnCCall_12
		( HRGN
		, winCreateEmptyRgn, winCreateRectRgn, winCreatePolygonRgn
		, winUnionRgn, winSectRgn, winDiffRgn, winXorRgn,
		, winGetRgnBox, winIsEmptyRgn
		, winDisposeRgn
		) where



import Graphics.UI.ObjectIO.OS.Cutil_12

type HRGN = Ptr ()


--	Operations to create, modify and destroy regions.
foreign import ccall "cpicture_121.h WinCreateEmptyRgn" winCreateEmptyRgn :: IO HRGN
foreign import ccall "cpicture_121.h WinCreateRectRgn" winCreateRectRgn :: Int -> Int -> Int -> Int -> IO HRGN
foreign import ccall "cpicture_121.h WinCreatePolygonRgn" winCreatePolygonRgn :: Ptr Int -> Int -> Int -> IO HRGN
foreign import ccall "cpicture_121.h WinUnionRgn" winUnionRgn :: HRGN -> HRGN -> IO HRGN
foreign import ccall "cpicture_121.h WinSectRgn" winSectRgn :: HRGN -> HRGN -> IO HRGN
foreign import ccall "cpicture_121.h WinDiffRgn" winDiffRgn :: HRGN -> HRGN -> IO HRGN
foreign import ccall "cpicture_121.h WinXorRgn" winXorRgn :: HRGN -> HRGN -> IO HRGN

winGetRgnBox :: HRGN -> IO (Int,Int,Int,Int,Bool)
winGetRgnBox a1 = do
    -- Marshal arguments:
    o1 <- malloc
    o2 <- malloc
    o3 <- malloc
    o4 <- malloc
    o5 <- malloc
    -- Call C:
    cWinGetRgnBox a1 o1 o2 o3 o4 o5
    -- Read/free:
    r1 <- fpeek o1
    r2 <- fpeek o2
    r3 <- fpeek o3
    r4 <- fpeek o4
    r5 <- fpeek o5
    return (r1,r2,r3,r4,r5)

foreign import ccall "cpicture_121.h WinGetRgnBox" cWinGetRgnBox :: HRGN -> Ptr Int -> Ptr Int -> Ptr Int -> Ptr Int -> Ptr Bool -> IO ()

foreign import ccall "cpicture_121.h WinIsEmptyRgn" winIsEmptyRgn :: HRGN -> IO Bool

foreign import ccall "cpicture_121.h WinDisposeRgn" winDisposeRgn :: HRGN -> IO ()
